from days.day_5 import parse_lines, get_vents_map

lines = [
    [(0, 9), (1, 9), (2, 9), (3, 9), (4, 9), (5, 9)],
    [(8, 0), (7, 1), (6, 2), (5, 3), (4, 4), (3, 5), (2, 6), (1, 7), (0, 8)],
    [(9, 4), (8, 4), (7, 4), (6, 4), (5, 4), (4, 4), (3, 4)],
    [(2, 2), (2, 1)],
    [(7, 0), (7, 1), (7, 2), (7, 3), (7, 4)],
    [(6, 4), (5, 3), (4, 2), (3, 1), (2, 0)],
    [(0, 9), (1, 9), (2, 9)],
    [(3, 4), (2, 4), (1, 4)],
    [(0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7), (8, 8)],
    [(5, 5), (6, 4), (7, 3), (8, 2)]
]


def test_parse_lines_exclude_diagonal():
    raw_lines = [
        '0,9 -> 5,9',
        '8,0 -> 0,8',
        '9,4 -> 3,4',
        '2,2 -> 2,1',
        '7,0 -> 7,4',
        '6,4 -> 2,0',
        '0,9 -> 2,9',
        '3,4 -> 1,4',
        '0,0 -> 8,8',
        '5,5 -> 8,2'
    ]

    expected = lines

    actual = parse_lines(raw_lines)

    assert actual == expected


def test_get_vents_map_excluding_diagonals():
    expected = {
        (0, 9): 2, (1, 9): 2, (2, 9): 2, (3, 9): 1, (4, 9): 1,
        (5, 9): 1, (9, 4): 1, (8, 4): 1, (7, 4): 2, (6, 4): 1,
        (5, 4): 1, (4, 4): 1, (3, 4): 2, (2, 2): 1, (2, 1): 1,
        (7, 0): 1, (7, 1): 1, (7, 2): 1, (7, 3): 1, (2, 4): 1,
        (1, 4): 1
    }

    actual = get_vents_map(lines, False)

    assert actual == expected


def test_get_vents_map_including_diagonals():
    expected = {
        (0, 9): 2, (1, 9): 2, (2, 9): 2, (3, 9): 1, (4, 9): 1,
        (5, 9): 1, (8, 0): 1, (7, 1): 2, (6, 2): 1, (5, 3): 2,
        (4, 4): 3, (3, 5): 1, (2, 6): 1, (1, 7): 1, (0, 8): 1,
        (9, 4): 1, (8, 4): 1, (7, 4): 2, (6, 4): 3, (5, 4): 1,
        (3, 4): 2, (2, 2): 2, (2, 1): 1, (7, 0): 1, (7, 2): 1,
        (7, 3): 2, (4, 2): 1, (3, 1): 1, (2, 0): 1, (2, 4): 1,
        (1, 4): 1, (0, 0): 1, (1, 1): 1, (3, 3): 1, (5, 5): 2,
        (6, 6): 1, (7, 7): 1, (8, 8): 1, (8, 2): 1}

    actual = get_vents_map(lines, True)

    assert actual == expected
